DECLARE SUB SixtyFourK (FromS%, FromO%, ToS%, ToO%)
DECLARE SUB CGAPixelPlot (cgax%, cgay%, cgac%)

DECLARE FUNCTION RGBtoPal% (InRd%, InGn%, InBl%, pal1() AS ANY)
DECLARE FUNCTION remmouseint% (func%, c%, r%)
DECLARE FUNCTION EmsAllocp% (numPages%)
DECLARE FUNCTION EMSCopy% ()
DECLARE FUNCTION emsfreep% (handle%)
DECLARE FUNCTION EMSMapP% (frame%, EmsPage%, handle%)
DECLARE FUNCTION EMSSwap% ()
DECLARE SUB setclip (x0%, y0%, x1%, y1%)
DECLARE SUB clipit (x0%, y0%, xs%, ys%, x00%, y00%, x11%, y11%)
DECLARE FUNCTION savegif% (name$, x1%, y1%, xs%, ys%)
DECLARE FUNCTION MFilesel$ (txt$)
DECLARE FUNCTION MouReadFmScrn$ (x0%, y0%, x1%, y1%)
'---------------------------------------------------------------------------
'Program: ANIMATED GIF VIEWER
'By     : Antoni Gual  14-12-2002 agual@eic.ictnet.es
'---------------------------------------------------------------------------
'Rich Geldreich made his pure QB GIF viewer back in 1993. Rich's program
'stopped halfway into the 89a spec, it displayed  all frames of an animated
'gif in succesion without proper timing. It lacked also a transparent color,
'and looping. No one has gone further since then.
'So I decided to do my version: featuring SVGA and full animated GIFS, a
'step-by step mode, a frame saver in PUT format and a mouse file selector.
'----------------------------------------------------------------------------

'PARTS OF GIF89A STANDARD NOT IMPLEMENTED IN THIS VERSION:
'   Revert to previous image as disposal method. It would need a buffer
'   User triggered images. Bah!
'   Viewable Text extensions .Who uses it?

'TO DO:
'ok Added MODE 13
'ok Redo the gif decode routine (not Rich's)
'ok Merge the microsecond timer
'ok Implement Global palette saving
'ok Revert to straight GET in decodegif, so i can put getbyte inside lzwdecode,
'ok Try a variable length buffer for lzwdwecode--doubled speed!!
'ok Implement Netscape looping App extension
'ok Implement user looping and image stop
'ok Center image
'OK File selector Abort-Retry should be mouse selected
'   Better user interface
'   A memory buffer to reduce flickering and allow return to previous image
'   Add GIF parameters viewer
'   Export to screen13
'   don't like palette compressed to 64 values...
'   An User Help

'
'KNOWN BUGS
'   opr006ar.gif black stripe in one frame. Would disappear with a buffer..
'   Mousefilesel scrolls if dir too big. IT'S A FEATURE! :D
'----------------------------------------------------------------------------
DEFINT A-Z
'$INCLUDE: 'QB.BI'
DECLARE FUNCTION DelayOrStep% (delay&)
DECLARE SUB lzwdecode (xstart, ystart, xlength, ylength, INTERLACED, TRANSP, palfile)
DECLARE FUNCTION setvesamode% (mode%)
DECLARE FUNCTION getbyte% ()
DECLARE FUNCTION decodegif (a$, cgafile, cgafile2)
DECLARE FUNCTION Driveready% (d$)
DECLARE FUNCTION mouseint% (func%, c%, r%)
DECLARE SUB setvesay (y)

DECLARE FUNCTION XTimerW& ()
'You can use these constants to convert XTimer readings to seconds
CONST clockfreq# = 1193181.666#           'PIT clock frequency
CONST hundsofsec# = clockfreq# / 100
COMMON SHARED decodecnt, CGAPixel(), foxoldclr  ', cgaout AS STRING * 16384

TYPE emstype                         'general ems data: frame segment, free pag
		init AS INTEGER                  'if init=0 EMS has not been initialized
		ver  AS INTEGER
		sg   AS INTEGER
		frep  AS INTEGER
		totp  AS INTEGER
END TYPE

TYPE memcopytype                     'this reg must be filled before a copy
		length AS LONG
		srctyp AS STRING * 1
		SrcHndl AS INTEGER
		SrcOfFs AS INTEGER
		SrcSgPg AS INTEGER
		dsttyp AS STRING * 1
		dsthndl AS INTEGER
		dstOfFs AS INTEGER
		dstSgPg AS INTEGER
END TYPE


DIM ems  AS emstype
DIM Emscopya AS memcopytype, emsbacka AS memcopytype
 DIM EmsPag(3)  AS LONG                  'saves the offsets of the 4 frames

TYPE skreentype
	minxs AS INTEGER
	minys AS INTEGER
	maxxs AS INTEGER
	maxys AS INTEGER
	minx AS INTEGER
	maxx AS INTEGER
	miny AS INTEGER
	maxy AS INTEGER
	linlen AS INTEGER
	mode AS INTEGER
END TYPE


TYPE gifheadertype
	sig AS STRING * 3
	ver AS STRING * 3
	wid AS INTEGER
	hei AS INTEGER
	pak AS STRING * 1
	BGI AS STRING * 1
	par AS STRING * 1
END TYPE

TYPE grctrlexttype
	siz AS STRING * 1
	pak AS STRING * 1
	DEL AS INTEGER
	TCI AS STRING * 1
	NUL AS STRING * 1
END TYPE

TYPE gifimdesctype
	lef AS INTEGER
	TOP AS INTEGER
	wid AS INTEGER
	hei AS INTEGER
	pak AS STRING * 1
END TYPE

TYPE textdesctype
	siz AS STRING * 1
	wid AS INTEGER
	hei AS INTEGER
	cwi AS STRING * 1
	the AS STRING * 1
	frm AS STRING * 1
	bgr AS STRING * 1
END TYPE

TYPE appexttype
 siz AS STRING * 1
 net AS STRING * 11
END TYPE

TYPE GIFLOOPTYPE
 XXX  AS INTEGER
 lop  AS INTEGER
 NUL  AS STRING * 1
END TYPE

'vesa handling
TYPE vluttype
	page AS INTEGER
	ofs  AS INTEGER
END TYPE
REDIM vlut(0) AS vluttype

TYPE Hues
  red AS INTEGER
  green AS INTEGER
  blue AS INTEGER
END TYPE

RESET

'Precalculate power of two tables for fast shifts.
DIM powersof2(30)  AS LONG, shiftout(8)
DIM SHL8(511) AS LONG
FOR a = 0 TO 30: powersof2(a) = 2 ^ a: NEXT
FOR a = 0 TO 255: SHL8(a) = a * 256&: SHL8(a + 256) = SHL8(a) * 256: NEXT
'DIM cgaout AS STRING * 16384

'RGBDn = ABS(INT((ClrW / 4) - 3))
'''cgaout = STRING$(16384, 32)

RESTORE
REDIM SHARED pal2(260) AS Hues
REDIM SHARED pal1(15) AS Hues

RESTORE
FOR WolfCode1 = 0 TO 15
  READ r, g, b
  pal1(WolfCode1).red = ABS(INT((r / 4) - 3))
  pal1(WolfCode1).green = ABS(INT((g / 4) - 3))
  pal1(WolfCode1).blue = ABS(INT((b / 4) - 3))
NEXT WolfCode1

SCREEN 0: WIDTH 80, 25: COLOR 7, 0: CLS
PRINT "Make RGB fix palette?"
INPUT answer$
IF LEFT$(UCASE$(answer$), 1) = "Y" THEN

f = FREEFILE
OPEN "CGAMATCH.DAT" FOR BINARY AS #f

FOR x = 0 TO 63
  FOR y = 0 TO 63
    FOR z = 0 TO 63
	 a$ = CHR$(32)
	 SEEK #f, CLNG(x) + CLNG(y) * 64& + CLNG(z) * 4096& + 1&
	 a$ = CHR$(RGBtoPal(x, y, z, pal1()))
	 PUT #f, , a$
    NEXT z
  NEXT y
  PRINT ".";
NEXT x
CLOSE #f

END

END IF

SCREEN 2
CLS

LOCATE 23, 1: PRINT "Drawing CGA/NTSC pixels"
REDIM CGAPixel(4 * 2 * 16)
FOR cgac = 0 TO 15
FOR z = 0 TO 3
  c = SGN(cgac AND (2 ^ ((4 + z - 1) MOD 4) XOR 0))
  PSET (z, 0), c
NEXT z
GET (0, 0)-(3, 0), CGAPixel(cgac * 7)
LINE (0, 0)-(3, 0), 0
NEXT cgac


dummy = mouseint(0, 0, 0)
'Screen mode
SCREEN 0: CLS
PRINT "screen mode 1 screen 13 /2 640X480 /3 800X600 4/1024x768 "; a
a = 1
SELECT CASE a
CASE 1: mmod = &H13
CASE 2: mmod = &H101
CASE 3: mmod = &H103
CASE 4: mmod = &H105
CASE ELSE: STOP
END SELECT

'Get GIF filename.
f$ = COMMAND$
quitnow = 0
DO
	'''IF f$ = "" THEN f$ = MFilesel$("Select a GIF to view")
	SHELL "dir *.gif /w"
	PRINT "*.GIF file to convert"
	INPUT f$
	'
	f$ = f$ + ".gif" ' Robin Gravel's code
	'
	INPUT "OUTPUT FILE:(*.CGA)"; CgaDrop$
	'''f$ = "c:\ggchess.gif"
	IF f$ = "" THEN EXIT DO
	'
	CgaDrop$ = CgaDrop$ + ".cga" ' Robin Gravel's code
	'
	'Open file for input so QB stops with an error if it doesn't exist.
	'
	' Robin Gravel's code
	INPUT "OUTPUT FILE:(*.pic)"; pic$ '
	IF f$ = "" THEN EXIT DO
	pic$ = pic$ + ".pic"
	'end of Robin Gravel's code
       
	OPEN f$ FOR INPUT ACCESS READ AS #1: CLOSE #1 ' Ici 1

	IF setvesamode(mmod) THEN STOP
	'wait for monitor to adapt to new mode
	T! = TIMER + .2: WHILE TIMER < T!: WEND
	T! = TIMER
    
	decodecnt = -1
	foxoldclr = -1
	wolffile = FREEFILE
	OPEN "CGAMATCH.DAT" FOR BINARY AS #wolffile
	catfile = FREEFILE
	OPEN CgaDrop$ FOR BINARY AS #catfile
	errc = decodegif(f$, wolffile, catfile)
	CLOSE #wolffile
	CLOSE #catfile

	T! = TIMER - T!
	IF errc = 0 THEN
		DO: LOOP UNTIL LEN(INKEY$) OR (mouseint(-3, 0, 0) AND 1)
	       
		' Robin Gravel's code
		DEF SEG = &HB800: BSAVE pic$, 0, 16384
		' end of Robin Gravel's code
	       
		dummy = setvesamode(3)
		SCREEN 0: WIDTH 80, 25: CLS
		PRINT T!
	ELSE
		dummy = setvesamode(3)
		SCREEN 0: WIDTH 80, 25: CLS
		SELECT CASE errc
		CASE 1: PRINT "File "; f$; " is not a GIF image."
		END SELECT
	END IF
	DO: LOOP UNTIL LEN(INKEY$) OR mouseint(-3, 0, 0) AND 1
	f$ = ""
	dummy = setvesamode(3)
	SCREEN 0: WIDTH 80, 25: CLS
	PRINT "Press ESC to quit or any other key to replay."
	WHILE INKEY$ <> "": WEND
	DO
	  key$ = INKEY$
	  IF key$ = CHR$(27) THEN quitnow = -1: EXIT DO
	LOOP WHILE key$ = ""
	IF quitnow THEN EXIT DO
	IF setvesamode(mmod) THEN STOP
LOOP
COLOR 7, 0: CLS
PRINT "Pure QuickBasic Animated GIF Viewer"
PRINT "Antoni Gual 12/2002   agual@eic.ictnet.es"
END


fileselerr: errata% = ERR: RESUME NEXT


'DOSBOX CGA Composite (Apple][e Double Hi-Res) Color Data
DATA 0,0,0
DATA 156,4,132
DATA 24,48,222
DATA 181,56,255
DATA 0,121,0
DATA 123,125,123
DATA 0,174,222
DATA 156,178,255
DATA 99,77,0
DATA 255,81,33
DATA 123,125,123
DATA 255,134,255
DATA 74,199,0
DATA 231,203,24
DATA 99,251,123
DATA 255,255,255

SUB CGAPixelPlot (cgax, cgay, cgac)

IF 1 = 0 THEN
FOR z = 0 TO 3
  c = SGN(cgac AND (2 ^ ((4 + z - 1) MOD 4) XOR 0))
  PSET (cgax * 4 + z, cgay), c
NEXT z
END IF
IF cgax < 159 THEN PUT (cgax * 4, cgay), CGAPixel(cgac * 7), PSET

END SUB

SUB clipit (x0, y0, xs, ys, x00, y00, x11, y11)
SHARED sk AS skreentype
	IF x0 < sk.minx THEN x00 = sk.minx ELSE x00 = x0
	IF y0 < sk.miny THEN y00 = sk.miny ELSE y00 = y0
	IF x0 + xs - 1 > sk.maxx THEN x11 = sk.maxx ELSE x11 = x0 + xs - 1
	IF y0 + ys - 1 > sk.maxy THEN y11 = sk.maxy ELSE y11 = y0 + ys - 1
END SUB

FUNCTION decodegif (a$, cgafile, cgafile2)
SHARED powersof2() AS LONG
SHARED jfile, sk AS skreentype
	DIM w AS LONG

	jfile = FREEFILE
	OPEN a$ FOR BINARY ACCESS READ AS #jfile
	DIM hdr AS gifheadertype, id AS gifimdesctype, ge AS grctrlexttype
	DIM app AS appexttype, loopit AS GIFLOOPTYPE
	'Get header and work with it...
	'Check to see if GIF file. Ignore GIF version number.
	GET jfile, , hdr
	IF hdr.sig <> "GIF" THEN CLOSE : decodegif = 1: EXIT FUNCTION

	xl = (sk.maxx - sk.minx - hdr.wid + 1) \ 2
	yt = (sk.maxy - sk.minx - hdr.hei + 1) \ 2

	globpal = (ASC(hdr.pak) AND 128) <> 0
	'Retrieve global palette if it exists.
	IF globpal THEN
		'the screen is preset to color 0 so no need to draw background if it's 0
		IF ASC(hdr.BGI) <> 0 THEN
			clipit xl, yt, hdr.wid, hdr.wid, nx, ny, mx, my
			GOSUB SETBACKG
		END IF
		globcolors = powersof2((ASC(hdr.pak) AND 7) + 1)
		globpal$ = SPACE$(globcolors * 3)
		GET jfile, , globpal$
		globpalset = 0
	ELSE
		globpalset = -1
	END IF

	'Variable part...
	g$ = " ": g1$ = " ": g2$ = " "
	TRANSP = -1: loops = 0: loopptr& = SEEK(jfile)
	DO
		'To cope with files without End Of Gif
		IF EOF(jfile) THEN g$ = CHR$(59) ELSE GET jfile, , g$
		SELECT CASE ASC(g$)
		CASE 0        'end of block
		CASE 33       'extension
			GET jfile, , g1$
			SELECT CASE ASC(g1$)
			CASE 1        'plain text extension
				GOSUB skipit
			CASE 249      'graphic ctrl ext
				'get delay , transparent color and erase command for next image
				GET jfile, , ge
				IF (ASC(ge.pak) AND 1) <> 0 THEN TRANSP = ASC(ge.TCI) ELSE TRANSP = -1
				IF (ASC(ge.pak) AND 8) THEN nexteraser = 1
				delay = ge.DEL: IF delay = 0 THEN delay = 1
			CASE 254      'comment
				GOSUB skipit
			CASE 255      'app extension. Have to check for netscape loop
				GET jfile, , app
				IF app.net = "NETSCAPE2.0" THEN
					 GET jfile, , loopit
					 IF loopit.lop = 0 THEN loopit.lop = -1
					 IF loops = 0 THEN loops = loopit.lop
				ELSE
					GOSUB skipit
				END IF
			CASE ELSE
				STOP
			END SELECT
		CASE 44       'image descriptor+local palette+image
			GET jfile, , id
			INTERLACED = (ASC(id.pak) AND 64) <> 0

			'if local color table exists, then get it
			locpalflag = (ASC(id.pak) AND 128) <> 0
			IF locpalflag THEN
				loccolors = powersof2((ASC(id.pak) AND 7) + 1)
				locpal$ = SPACE$(loccolors * 3)
				GET jfile, , locpal$
			END IF

			'deal with delays,stepping
			IF DelayOrStep(delay&) THEN EXIT DO

			'if previous image must be erased, do it
			IF ERASER THEN GOSUB SETBACKG: ERASER = 0
			IF locpalflag THEN
				GOSUB setpalette
				IF globpalset = 1 THEN globpalset = 0
			ELSEIF globpalset = 0 THEN
				locpal$ = globpal$
				loccolors = globcolors
				GOSUB setpalette
				globpalset = 1
			END IF
			'decode image to screen
			  'decodecnt = -1
			  f = cgafile
			  lzwdecode xl + id.lef, yt + id.TOP, id.wid, id.hei, INTERLACED, TRANSP, f
			  'DEF SEG = &HB800
			  'SUB SixtyFourK (FromS, FromO, ToS, ToO)
			  '''SixtyFourK &HB800, 0, VARSEG(cgaout), SADD(cgaout)
			  DEF SEG = &HB800
			  FOR nul1 = 0 TO 16383
			    cgaout$ = CHR$(PEEK(nul1))
			    PUT #cgafile2, , cgaout$
			  NEXT nul1
			  DEF SEG


			

			TRANSP = -1:
			ERASER = nexteraser: nexteraser = 0
			IF ERASER THEN clipit id.lef + xl, id.TOP + yt, id.wid, id.hei, nx, ny, mx, my
		CASE 59       'end of gif

			SELECT CASE loops
			CASE -1
			  '''SEEK jfile, loopptr&
			  EXIT DO
			CASE 0: EXIT DO
			CASE ELSE
			   EXIT DO
			   loops = 1
			   loops = loops - 1: SEEK jfile, loopptr&
			END SELECT
		CASE ELSE
			STOP  'Wrong GIF Sequence!
		END SELECT
		'''u! = TIMER: WHILE TIMER - u! < .001: WEND

	LOOP
 CLOSE jfile
EXIT FUNCTION

skipit:
 DO
	GET jfile, , g2$
	bl = ASC(g2$)
	IF bl THEN
	 a$ = SPACE$(bl)
	 GET jfile, , a$
	END IF
 LOOP UNTIL bl = 0
RETURN
EXIT FUNCTION

SETBACKG:
p = ASC(hdr.BGI)
REM WAIT &H3DA, 8
FOR I = ny TO my
'''setvesay I
FOR j = nx TO mx
	'''POKE j, p
'************************* KIYOTE
	CGAPixelPlot j, p, RGBtoPal(pal2(p).red, pal2(p).green, pal2(p).blue, pal1())
NEXT
NEXT
RETURN

setpalette:
'************************* KIYOTE
REM OUT &H3C8, 0
palcnt = 0
FOR I = 1 TO loccolors * 3 STEP 3
'''T = ASC(MID$(locpal$, I)) / 4: IF T > 63 THEN T = 63
'''OUT &H3C9, T
T = ASC(MID$(locpal$, I)) / 4: IF T > 63 THEN T = 63
pal2(palcnt).red = T
T = ASC(MID$(locpal$, I + 1)) / 4: IF T > 63 THEN T = 63
pal2(palcnt).green = T
T = ASC(MID$(locpal$, I + 2)) / 4: IF T > 63 THEN T = 63
pal2(palcnt).blue = T
palcnt = palcnt + 1
NEXT
RETURN



END FUNCTION

FUNCTION DelayOrStep (delay&)
 'Returns after delay expired or user pressed a key
 STATIC PrevDelay&, steps
	IF PrevDelay& THEN
		DO
			click = mouseint(-3, r, c)
			IF LEN(INKEY$) OR click AND 1 THEN DelayOrStep = 1
			IF click AND 2 THEN : steps = NOT steps: BEEP
		LOOP UNTIL (XTimerW& > PrevDelay&) OR click
		IF click THEN T! = TIMER + .1: DO: LOOP UNTIL TIMER > T!
		PrevDelay& = 0
	ELSEIF steps THEN
		click = 0
		DO
			click = mouseint(-3, r, c)
			IF click AND 2 THEN steps = NOT steps: BEEP
		LOOP UNTIL (INKEY$ = " ") OR click
		T! = TIMER + .1: DO: LOOP UNTIL TIMER > T!
	END IF
	'if this image has also a delay, start it
	IF NOT steps THEN
		IF delay& THEN PrevDelay& = XTimerW& + CLNG(CLNG(delay&) * CLNG(hundsofsec#)): delay& = 0
	END IF
END FUNCTION

FUNCTION Driveready% (d$)
'Check if a disk is ready.
'by Antoni Gual 9/2002 agual@eic.ictnet.es
' 53 if disk is ready
' 71 if disk exists but is not ready
' 76 if disk is not ready
' 64 if disk letter is out of range
' 0  if disk is ready but is an audio CD!
'you need to setup this error handler at the end of the main module:
'fileselerr: errata% = ERR: RESUME NEXT
'--------------------------------------------------------------------
 SHARED errata%
 'If disk B is disabled, don't check for it!
 IF d$ = "B:" THEN
	 OUT &H70, &H10: IF (INP(&H71) AND 7) = 0 THEN Driveready% = 64: EXIT FUNCTION
 END IF
 ON ERROR GOTO fileselerr
 f% = FREEFILE
 OPEN d$ + "\track01.cda" FOR INPUT AS f%
 IF errata% = 0 THEN CLOSE f%
 Driveready% = errata%
 errata% = 0
 ON ERROR GOTO 0
END FUNCTION

FUNCTION EmsAllocp (numPages)
'Allocate pages. First time it's called it checks for EMS
'Returns negative values if error, positive if a handler has been assigned
SHARED ems  AS emstype, regs AS RegType, EmsPag() AS LONG
IF NOT ems.init THEN
	 '-1 handler EMS not avialable
	 regs.ax = &H4000
	 CALL INTERRUPT(&H67, regs, regs)
	 IF regs.ax \ 256 THEN EmsAllocp = -1: EXIT FUNCTION


	 regs.ax = &H4200
	 CALL INTERRUPT(&H67, regs, regs)
	 ems.frep = regs.bx
	 ems.totp = regs.dx
	 IF regs.ax \ 256 THEN EmsAllocp = -2: EXIT FUNCTION

	 GOSUB freep

	 regs.ax = &H4600
	 CALL INTERRUPT(&H67, regs, regs)
	 ems.ver = regs.ax AND 255
	 IF regs.ax \ 256 THEN EmsAllocp = -5: EXIT FUNCTION



	 regs.ax = &H4100
	 CALL INTERRUPT(&H67, regs, regs)
	 ems.sg = regs.bx
	 IF regs.ax \ 256 THEN EmsAllocp = -3: EXIT FUNCTION

	 T& = 0
	 FOR I% = 0 TO 3
			EmsPag(I%) = T&
			T& = T& + &H4000
	 NEXT
	 ems.init = -1
END IF

IF ems.frep = 0 THEN EXIT FUNCTION

regs.ax = &H4300
regs.bx = numPages
CALL INTERRUPT(&H67, regs, regs)
IF (regs.ax \ 256) THEN
	 res = -4
ELSE
	 res = regs.dx
END IF

GOSUB freep
EmsAllocp = res
EXIT FUNCTION

freep:
	 regs.ax = &H4200
	 CALL INTERRUPT(&H67, regs, regs)
	 ems.frep = regs.bx
	 ems.totp = regs.dx
	 IF regs.ax \ 256 THEN EmsAllocp = -2: EXIT FUNCTION
RETURN

END FUNCTION

'' BIOS call to run an extremely quick memory copy routine that is provided by
' EMS.
FUNCTION EMSCopy
SHARED Emscopya  AS memcopytype, regsx AS RegTypeX
regsx.ax = &H5700
regsx.ds = VARSEG(Emscopya)
regsx.si = VARPTR(Emscopya)
CALL INTERRUPTX(&H67, regsx, regsx)
EMSCopy = regsx.ax \ 256
END FUNCTION

' BIOS call to deallocate EMS pages.
FUNCTION emsfreep (handle)
SHARED regs AS RegType
regs.ax = &H4500
regs.dx = handle
CALL INTERRUPT(&H67, regs, regs)
emsfreep = regs.ax \ 256

END FUNCTION

' BIOS call to map EMS to conventional memory.
FUNCTION EMSMapP (frame, EmsPage, handle)
SHARED regs AS RegType
regs.ax = &H4400 OR (frame AND 3)
regs.bx = EmsPage
regs.dx = handle
CALL INTERRUPT(&H67, regs, regs)
EMSMapP = regs.ax \ 256
END FUNCTION

FUNCTION EMSSwap
SHARED Emscopya  AS memcopytype, regsx AS RegTypeX
IF Emscopya.SrcHndl = 0 THEN Emscopya.srctyp = CHR$(0) ELSE Emscopya.srctyp = CHR$(1)
IF Emscopya.dsthndl = 0 THEN Emscopya.dsttyp = CHR$(0) ELSE Emscopya.dsttyp = CHR$(1)
regsx.ax = &H5701
regsx.ds = VARSEG(Emscopya)
regsx.si = VARPTR(Emscopya)
CALL INTERRUPTX(&H67, regsx, regsx)
EMSSwap = regsx.ax \ 256
END FUNCTION

SUB lzwdecode (xstart, ystart, xsize, ysize, INTERLACED, TRANSP, palfile)
	'We save the strings in string table as a PrefixCode + a SuffixChar.
	' The Prefix code is an index to a new pair PrefixCode+SuffixChar, and so
	' on until the PrefixCode is -1. This avoids using variable length strings.

	SHARED powersof2() AS LONG, SHL8() AS LONG, shiftout()
	SHARED jfile
	SHARED sk AS skreentype
	DIM prefixcod(4095), suffixchar(4095), outstack(4095)
	xmax = xstart + xsize - 1
	ymax = ystart + ysize - 1
	'Calculate clear code, end of stream code, and first free LZW code.
	g$ = " ": GET jfile, , g$
	aaa = ASC(g$)
	clearcode = powersof2(aaa)
	eoscode = clearcode + 1
	FOR I = 0 TO clearcode + 1: prefixcod(I) = -1: suffixchar(I) = I: NEXT
	FirstCode = clearcode + 2
	StartCodeSize = aaa + 1
	startmaxcode = powersof2(StartCodeSize) - 1

	'init Screen output GOSUB
	PassNumber = 0: PassStep = 8
	x = xmax + 1
	IF INTERLACED THEN y = ystart - PassStep ELSE y = ystart - 1

	'pointers to bit fetchers
	bitsin = 0: blockpointer = 0

	'LZW decoding loop.
	codesize = StartCodeSize
	'WAIT &H3DA, 8
	DO
		'Retrieve one LZW code.
		GOSUB getcode
		SELECT CASE code
		CASE -1
			'End also if getcode found a zero-sized block
			EXIT DO
		CASE eoscode
			'not all images end by a clear EOS code..
			EXIT DO
		CASE clearcode
			WHILE code = clearcode
			 'clear dictionnary, reset code length
			 codesize = StartCodeSize
			 NEXTCODE = FirstCode
			 maxcode = startmaxcode
			 'reinit the code stack
			 GOSUB getcode
			 IF code <> clearcode THEN
					IF code = eoscode THEN EXIT DO
					outstack(0) = suffixchar(code)
					sptr = 0
					GOSUB display
					old = code
			 END IF
			WEND
		'a normal code
		CASE ELSE
			IF code < NEXTCODE THEN
				sptr = -1: I = code
				GOSUB getoutput
			ELSEIF code = NEXTCODE THEN
				I = old: sptr = 0
				GOSUB getoutput
				outstack(0) = outstack(sptr)
			ELSE
				'code can't be bigger than next free code or we would have a hole in
				'the dictionnary
				 STOP
			END IF
			'Display it
			decodecnt = (decodecnt + 1) MOD 4
			GOSUB display
		END SELECT
	LOOP
ImageDone:
ERASE prefixcod, suffixchar, outstack
EXIT SUB

getoutput:
	'build the output string
	WHILE I > -1
		sptr = sptr + 1
		outstack(sptr) = suffixchar(I)
		I = prefixcod(I)
	WEND
	'add a new entry to dictionnary
	prefixcod(NEXTCODE) = old
	suffixchar(NEXTCODE) = outstack(sptr)
	old = code
	'increase the dictionnary pointer
	NEXTCODE = NEXTCODE + 1
	'If we reached maximum value for a given codesize, increase codesize
	'if we're not at maximum size (a clearcode should arrive soon)
	IF NEXTCODE > maxcode AND codesize < 12 THEN codesize = codesize + 1: maxcode = powersof2(codesize) - 1
RETURN


'Adds the string just decoded to display
display:
	'read backwards the output stack
	WHILE sptr > -1
		IF x > xmax THEN
			IF INTERLACED THEN
				y = y + PassStep
					IF y > ymax THEN
							PassNumber = PassNumber + 1
							SELECT CASE PassNumber
							CASE 1: y = ystart + 4: PassStep = 8
							CASE 2: y = ystart + 2: PassStep = 4
							CASE 3: y = ystart + 1: PassStep = 2
							END SELECT
					END IF
			ELSE
					y = y + 1
			END IF
			IF y >= sk.miny AND y <= sk.maxy THEN
			  REM setvesay y
			END IF
			x = xstart
		END IF
		IF x >= sk.minx AND x <= sk.maxx AND y >= sk.miny AND y <= sk.maxy THEN
			'************************* KIYOTE
			 
			  REM IF NOT (x AND 1) THEN
			   'decodecnt = (decodecnt + 1) MOD 4
			   'IF decodecnt = 0 THEN
			    IF y AND 1 OR 1 THEN
			    REM POKE x, outstack(sptr)
			    '''FoxCode1 = RGBtoPal(
			    Foxp = outstack(sptr)
			    IF foxoldclr <> Foxp THEN
				 FoxR = pal2(Foxp).red
				 FoxG = pal2(Foxp).green
				 FoxB = pal2(Foxp).blue
				 FileAddr& = CLNG(FoxR) + CLNG(FoxG) * 64& + CLNG(FoxB) * 4096& + 1&
				 a$ = CHR$(32)
				 SEEK #palfile, FileAddr&
				 GET #palfile, , a$
				 FoxClr = ASC(a$)
			    END IF

			    CGAPixelPlot x / 2, y, FoxClr
			    foxoldclr = Foxp
			    END IF
			  END IF
			  REM END IF
			'END IF
			
		'''END IF
		x = x + 1
		sptr = sptr - 1
	WEND
	
RETURN

display2:
	'read backwards the output stack
	WHILE sptr > -1
		IF x > xmax THEN
			IF INTERLACED THEN
				y = y + PassStep
					IF y > ymax THEN
							PassNumber = PassNumber + 1
							SELECT CASE PassNumber
							CASE 1: y = ystart + 4: PassStep = 8
							CASE 2: y = ystart + 2: PassStep = 4
							CASE 3: y = ystart + 1: PassStep = 2
							END SELECT
					END IF
			ELSE
					y = y + 1
			END IF
			IF y >= sk.miny AND y <= sk.maxy THEN
			  REM setvesay y
			END IF
			x = xstart
		END IF
		IF x >= sk.minx AND x <= sk.maxx AND y >= sk.miny AND y <= sk.maxy THEN
			'************************* KIYOTE
			
			  REM IF NOT (x AND 1) THEN
			   'decodecnt = (decodecnt + 1) MOD 4
			   'IF decodecnt = 0 THEN
			    IF y AND 1 THEN
			    REM POKE x, outstack(sptr)
			    '''FoxCode1 = RGBtoPal(
			    'Foxp = outstack(sptr)
			    'IF foxoldclr <> Foxp THEN
			    '  FoxR = pal2(Foxp).red
			    '  FoxG = pal2(Foxp).green
			    '  FoxB = pal2(Foxp).blue
			    '  FileAddr& = CLNG(FoxR) + CLNG(FoxG) * 64& + CLNG(FoxB) * 4096& + 1&
			    '  A$ = CHR$(32)
			    '  SEEK #palfile, FileAddr&
			    '  GET #palfile, , A$
			    '  FoxClr = ASC(A$)
			    END IF

			    'CGAPixelPlot x / 2, y, FoxClr
			    'foxoldclr = Foxp
			    '''END IF
			  END IF
			  REM END IF
			'END IF
		    
		'''END IF
		x = x + 1
		sptr = sptr - 1
	WEND
    
RETURN


'Reads a codesize sized code from the data stream,skipping block headers.
getcode:
	pad& = 0: blocksize = 0: j = 0
	IF bitsin THEN pad& = workcode: blocksize = bitsin
	WHILE blocksize < codesize

		'if end of block get following block size
		IF blockpointer = 0 THEN
			 IF EOF(jfile) THEN code = -1: RETURN
			 GET jfile, , g$: blockpointer = ASC(g$)
			 'found a zero size block, end (not in the spec!!)
			 IF blockpointer = 0 THEN code = -1: RETURN
			 IF blockpointer <> lbp THEN g1$ = SPACE$(blockpointer): lbp = blockpointer
			 GET jfile, , g1$: ii = 1
		END IF
		workcode = ASC(MID$(g1$, ii, 1)): blockpointer = blockpointer - 1: ii = ii + 1
		pad& = pad& OR SHL8(workcode + j)
		j = j + 256
		blocksize = blocksize + 8
	WEND

	'shift right and mask code
	code = (pad& \ powersof2(8 - bitsin)) AND (powersof2(codesize) - 1)
	IF blocksize >= codesize THEN bitsin = blocksize - codesize ELSE bitsin = 0
RETURN

END SUB

FUNCTION MFilesel$ (txt$)
'Mouse File browser:returns file name selected by user in a text screen
'It does end when a file is selected, CANCEL is clicked or a key is pressed
'by Antoni Gual 9/2002 agual@eic.ictnet.es
'uses :
' Driveready function
' MouReadFmScrn$ function Reads from screen buffer the word the user has clicked on
' DOS shell  calls DIR *.* /w/on , CD.. , CD dirname  AND driveletter:
'------------------------------------------------------------------------------
SHARED errata
STATIC aa$
bb$ = txt$
'First time create a string with all available drivers
IF LEN(aa$) = 0 THEN
	aa$ = " "
	FOR I = 65 TO 90
	 b$ = CHR$(I) + ":"
	 SELECT CASE Driveready(b$)
		CASE 53, 71, 0: aa$ = aa$ + b$ + "  "      'drive exists
		CASE 64, 76:                               'drive does not exist
		CASE ELSE: STOP                            'unexpected error
	 END SELECT
	NEXT
END IF

SCREEN 0: WIDTH 80, 25: CLS
'selection loop
DO
 fil$ = ""
 'refresh directory display
 COLOR 7, 0:
 CLS
 'format screen
 SHELL ("dir *.* /w/on")
 'get last line with directory entries
 bttm = CSRLIN - 3
 COLOR 7, 12:
 LOCATE 5, 1: PRINT SPACE$(80); : LOCATE , 1: PRINT aa$ + "--CANCEL--";
 LOCATE 1, 1: PRINT SPACE$(80); : LOCATE , 1: PRINT bb$;

 'read  file name from screen
 b$ = MouReadFmScrn$(1, 5, 80, bttm)

 'depending on the word clicked
 SELECT CASE LCASE$(b$)
 CASE "": EXIT FUNCTION
 'go to parent dir
 CASE "[..]": SHELL "cd.."
 'clicked on a drive, check if it's ready, else
 CASE "a:", "b:", "c:", "d:", "e:", "f:", "g:", "h:", "i:", "j:", "k:", "l:", "m:", "n:", "o:", "p:", "q:", "r:", "s:", "t:", "u:", "v:", "x:", "y:", "z:"
	 DO
	 a% = Driveready%(b$)
	 SELECT CASE a%
	 CASE 53: SHELL b$: EXIT DO                        'drive ready
	 CASE 71, 0: LOCATE 1, 60: PRINT "Retry? Abort?"   'not ready
		 a$ = MouReadFmScrn$(60, 1, 73, 1)
		 SELECT CASE LCASE$(a$)
		 CASE "abort?": LOCATE 1, 60: PRINT SPACE$(20); : EXIT DO
		 CASE "retry?":
		 CASE ELSE
		 END SELECT
	 CASE ELSE: STOP
	 END SELECT
	 LOOP
 'Abort on Cancel
 CASE "--cancel--":
	 dummy = mouseint(2, 0, 0): EXIT DO
 'If brackets its's dir name so CHDIR, else it's a file so exit
 CASE ELSE
	 IF LEFT$(b$, 1) = "[" AND RIGHT$(b$, 1) = "]" THEN
	 SHELL "cd " + MID$(b$, 2, LEN(b$) - 2)
	 ELSE
	 fil$ = b$
	 END IF
 END SELECT
 'dummy = mouseint(2, 0, 0)

LOOP UNTIL LEN(fil$)
MFilesel$ = fil$
COLOR 7, 0: CLS
END FUNCTION

FUNCTION MouReadFmScrn$ (x0, y0, x1, y1)
'reads from text screen buffer the word the user has clicked on
'It waits until user clicks a non-space char or presses a key
'------------------------------------------------------------------------------
'x0,y0 are top left corner column and row limits for mouse
'x1,y1 ara bottom right corner column and row
'A word is any string of chars delimited by left & right spaces or mouse limits
'------------------------------------------------------------------------------
 IF x0 < 1 THEN x0 = 1
 IF y0 < 1 THEN y0 = 1
 IF x1 > 80 THEN x1 = 80
 dummy = mouseint(0, 0, 0)                           'init text mouse
 dummy = mouseint(7, x0, x1)                         'limit mouse cols
 dummy = mouseint(8, y0, y1)                         'limit mouse rows

 'Every time I center the mouse I have some ghost clicks waiting!
 dummy = mouseint(4, (x1 + x0) \ 2, (y1 + y0) \ 2)  'center mouse
 'so i loop to delete them...
 DO: dummy = mouseint(3, c, r): LOOP WHILE dummy

 dummy = mouseint(1, 0, 0)                           'and show it
 'get the word in screen the  user has  clicked
 DO
	 DO
	 click = mouseint(-3, c, r) AND 1
	 'if user presses a key, Abort it...
	 IF LEN(INKEY$) THEN GOTO MouReadFmScrnEnd
	 LOOP UNTIL click
	 'returns only words
	 IF SCREEN(r, c) <> 32 THEN
	 b$ = "": C1 = c
	 DO
		 a = SCREEN(r, C1): b$ = b$ + CHR$(a): C1 = C1 + 1:
	 LOOP UNTIL a = 32 OR C1 > x1
	 IF c > 1 THEN
		 C1 = c - 1
		 DO
		 a = SCREEN(r, C1): b$ = CHR$(a) + b$: C1 = C1 - 1
		 LOOP UNTIL a = 32 OR C1 < x0
	 END IF
	 b$ = LTRIM$(RTRIM$(b$))
	 END IF
 LOOP UNTIL LEN(b$)
MouReadFmScrnEnd:
MouReadFmScrn$ = b$
dummy = mouseint(2, 0, 0)
END FUNCTION

FUNCTION mouseint% (func%, c%, r%) STATIC
'---------------------------------------------------------------------------'
'QBASIC MOUSE ROUTINE BY ANTONI GUAL agual@eic.ictnet.es
'Needs only 'Include QB.BI' in the main module
'Can work with user (integer) scaling and offset or automatic scaling
'-----------------------------------------------------------------------------
STATIC hsc%, vsc%, hoff%, voff%
SHARED regsx AS RegTypeX
 '''hsc% = 2: vsc% = 2
 regsx.ax% = ABS(func%)
 SELECT CASE regsx.ax%
 CASE 1, 2: GOSUB imouse                         'show, hide

 CASE 3                                          'Get pos and clicks
 GOSUB imouse
	c% = regsx.cx% \ hsc% + hoff%
	r% = regsx.dx% \ vsc% + voff%
	mouseint% = regsx.bx%
 CASE -3                                         'Get pos and clicks, wait
	GOSUB imouse                                   'mouse release
	c% = regsx.cx% \ hsc% + hoff%
	r% = regsx.dx% \ vsc% + voff%
	tmp% = regsx.bx%
	IF tmp% THEN
	 DO: regsx.ax = 3: GOSUB imouse: LOOP UNTIL regsx.bx% = 0
	END IF
	mouseint% = tmp%
 CASE 0                                          'reset
	GOSUB imouse: mouseint% = regsx.ax%           'mouse reset result
	IF regsx.ax% = 0 THEN EXIT FUNCTION
	SELECT CASE c%                               'set default scaling
	CASE -1 'do nothing with scale, if it's not 0
		IF vsc% = 0 THEN vsc% = 1
		IF hsc% = 0 THEN hsc% = 1
	CASE 0  'text scaling
		'**********************************************
		DEF SEG = &H40: hsc% = 640 / PEEK(&H4A): hoff% = 1: voff% = 1
		'''DEF SEG = &H40: hsc% = 1: hoff% = 1: voff% = 1
		SELECT CASE PEEK(&H49)
		CASE 15, 16:  vsc% = 16: IF PEEK(&H84) = 42 THEN vsc% = 8
		CASE 17, 18: vsc% = 16: IF PEEK(&H84) = 59 THEN vsc% = 8
		CASE ELSE: vsc% = 8
		END SELECT
	CASE 2:  'graph mode scaling
		DEF SEG = &H40: hoff% = 1: voff% = 1: vsc% = 1: dummy = PEEK(&H4A)
		SELECT CASE PEEK(&H49)
		CASE 4, 13, 19: hsc% = 2
		CASE ELSE: hsc% = 1
		END SELECT
	END SELECT
	DEF SEG
 CASE 4                                          'set pos
	regsx.cx% = (c% - hoff%) * hsc%
	regsx.dx% = (r% - voff%) * vsc%
	GOSUB imouse
 CASE 7
	regsx.cx% = (c% - voff%) * vsc% + vsc% \ 2      'set limits
	regsx.dx% = (r% - voff%) * vsc% + vsc% \ 2
	GOSUB imouse
 CASE 8
	regsx.cx% = (c% - hoff%) * hsc% + hsc% \ 2       'set limits
	regsx.dx% = (r% - hoff%) * hsc% + hsc% \ 2
	GOSUB imouse
 CASE 9
	regsx.bx = 0
	regsx.cx = 0
	regsx.es = c%
	regsx.dx = r%
	GOSUB imouse
 CASE 10, -10
	IF func% > 0 THEN regsx.bx = 0 ELSE regsx.bx = 1
	regsx.cx = c%
	regsx.dx = r%
	GOSUB imouse
 CASE -1
	hsc% = c%: vsc% = r%
 CASE -2
	hoff% = c%: voff% = r%
 END SELECT
EXIT FUNCTION

imouse: CALL INTERRUPTX(&H33, regsx, regsx): RETURN
END FUNCTION

FUNCTION remmouseint% (func%, c%, r%) STATIC
		'**********************************************
		'''DEF SEG = &H40: hsc% = 640 / PEEK(&H4A): hoff% = 1: voff% = 1
		DEF SEG = &H40: hsc% = 1: hoff% = 1: voff% = 1
END FUNCTION

FUNCTION RGBtoPal (InRd, InGn, InBl, pal1() AS Hues)
'Used to import graphics into a new palette automatically
low! = SQR(63 ^ 2 + 63 ^ 2 + 63 ^ 2) 'Make room for all possibilities
newclr = 0

FOR n = 0 TO 15

  temp.red = pal1(n).red
  temp.green = pal1(n).green
  temp.blue = pal1(n).blue
  x1delta = InRd - temp.red: y1delta = InGn - temp.green: z1delta = InBl - temp.blue
  z2delta! = SQR(x1delta ^ 2 + y1delta ^ 2 + z1delta ^ 2)
  IF z2delta! < low! THEN
    newclr = n
    low! = z2delta!
  END IF

NEXT

RGBtoPal = newclr

END FUNCTION

FUNCTION savegif% (name$, x0, y0, xs, ys)
SHARED sk  AS skreentype
setclip 0, 0, 319, 119
clipit x0, y0, xs, ys, x00, y00, x11, y11
xss = x11 - x00 + 1
yss = x11 - x00 + 1
arr = (CLNG(xss) * yss) \ 2 + 2
REDIM toget(arr)

SELECT CASE sk.mode
CASE &H13
	GET (x00, y00)-(x11, y11), toget
CASE &H101
	toget(0) = 8 * xss
	toget(1) = y
	pp = 2
	FOR I = y00 TO y11
		setvesay (I)
		FOR j = x00 TO x11 STEP 2
			 toget(pp) = PEEK(j) + 256& * PEEK(j + 1)
			 pp = pp + 2
		NEXT
	NEXT
CASE ELSE
 STOP
END SELECT
DEF SEG = VARSEG(toget)
BSAVE name$, toget, (UBOUND(toget) + 1) * 2
setclip -1, -1, -1, -1
ERASE toget
END FUNCTION

SUB setclip (x0, y0, x1, y1)
SHARED sk AS skreentype
IF x0 < 0 THEN sk.minx = sk.minxs ELSE sk.minx = x0
IF y0 < 0 THEN sk.miny = sk.minys ELSE sk.miny = x0
IF x1 < 0 THEN sk.maxx = sk.maxxs ELSE sk.maxx = x1
IF y1 < 0 THEN sk.maxy = sk.maxys ELSE sk.maxy = y1
END SUB

SUB setEMSy
SHARED vlut() AS vluttype, regs AS RegType, sk AS skreentype
STATIC curbank, CURY
	 IF y = CURY THEN EXIT SUB
	 CURY = y
		DEF SEG = vlut(y).ofs
		IF sk.mode < 256 THEN EXIT SUB
		IF vlut(y).page <> curbank THEN
			curbank = vlut(y).page
			regs.ax = &H4F05: regs.bx = 0: regs.dx = curbank
			CALL INTERRUPT(&H10, regs, regs)
		END IF
END SUB

FUNCTION setvesamode (mode)
'---------------------------------------------------------
'sets vesa mode, sets line length and makes lookup tables
'does not calculate line len
'returns 0 if all ok
'---------------------------------------------------------
SHARED vlut() AS vluttype, regs AS RegType, sk AS skreentype
SELECT CASE mode
CASE 3
	regs.ax = &H4F02
	regs.bx = 3
	CALL INTERRUPT(&H10, regs, regs)
	SCREEN 0
	REDIM vlut(0) AS vluttype
	EXIT FUNCTION
CASE &H101
	sk.maxxs = 639
	sk.minxs = 0
	sk.maxys = 479
	sk.minys = 0
	sk.linlen = 1024
	sk.mode = &H101
	'set mode
	regs.ax = &H4F02
	regs.bx = mode
	CALL INTERRUPT(&H10, regs, regs)
	IF regs.ax <> &H4F THEN setvesamode = 2: EXIT FUNCTION

	'Set line Length
	regs.ax = &H4F06
	regs.bx = 0
	regs.cx = sk.linlen
	CALL INTERRUPT(&H10, regs, regs)
	IF regs.ax <> &H4F OR regs.cx <> sk.linlen THEN
		dummy = setvesamode(3)
		setvesamode = 3: EXIT FUNCTION
	END IF
CASE &H103
	sk.maxxs = 799
	sk.minxs = 0
	sk.maxys = 599
	sk.minys = 0
	sk.linlen = 1024
	sk.mode = &H103
	'set mode
	regs.ax = &H4F02
	regs.bx = mode
	CALL INTERRUPT(&H10, regs, regs)
	IF regs.ax <> &H4F THEN setvesamode = 2: EXIT FUNCTION

	'Set line Length
	regs.ax = &H4F06
	regs.bx = 0
	regs.cx = sk.linlen
	CALL INTERRUPT(&H10, regs, regs)
	IF regs.ax <> &H4F OR regs.cx <> sk.linlen THEN
		dummy = setvesamode(3)
		setvesamode = 3: EXIT FUNCTION
	END IF
CASE &H105
	sk.maxxs = 1023
	sk.minxs = 0
	sk.maxys = 767
	sk.minys = 0
	sk.linlen = 1024
	sk.mode = &H105
	'set mode
	regs.ax = &H4F02
	regs.bx = mode
	CALL INTERRUPT(&H10, regs, regs)
	IF regs.ax <> &H4F THEN setvesamode = 2: EXIT FUNCTION

	'Set line Length
	regs.ax = &H4F06
	regs.bx = 0
	regs.cx = sk.linlen
	CALL INTERRUPT(&H10, regs, regs)
	IF regs.ax <> &H4F OR regs.cx <> sk.linlen THEN
		dummy = setvesamode(3)
		setvesamode = 3: EXIT FUNCTION
	END IF

CASE &H13
	sk.maxxs = 319
	sk.minxs = 0
	sk.maxys = 199
	sk.minys = 0
	sk.linlen = 320
	sk.mode = &H13
	SCREEN 2
CASE ELSE
	setvesamode = 4: EXIT FUNCTION
END SELECT
setclip -1, -1, -1, -1
'make line lut
oflin& = sk.linlen \ 16
T& = 0
REDIM vlut(sk.miny TO sk.maxy) AS vluttype
FOR I = sk.miny TO sk.maxy
	vlut(I).page = T& \ &H10000
	vlut(I).ofs = &HA000 + ((oflin& * I) AND &HFFF)
	T& = T& + sk.linlen
NEXT

setvesay sk.maxy

END FUNCTION

SUB setvesay (y)
SHARED vlut() AS vluttype, regs AS RegType, sk AS skreentype
STATIC curbank, CURY
	 IF y = CURY THEN EXIT SUB
	 CURY = y
		DEF SEG = vlut(y).ofs
		IF sk.mode < 256 THEN EXIT SUB
		IF vlut(y).page <> curbank THEN
			curbank = vlut(y).page
			regs.ax = &H4F05: regs.bx = 0: regs.dx = curbank
			CALL INTERRUPT(&H10, regs, regs)
		END IF
END SUB

SUB SixtyFourK (FromS, FromO, ToS, ToO)

'ASM Screen page copying routine.
'modified to do &h4000 bytes for SCREEN 2
PageCopy$ = ""
PageCopy$ = PageCopy$ + CHR$(&H1E)                          ' PUSH DS
PageCopy$ = PageCopy$ + CHR$(&H55)                          ' PUSH BP
PageCopy$ = PageCopy$ + CHR$(&H89) + CHR$(&HE5)             ' MOV BP,SP
PageCopy$ = PageCopy$ + CHR$(&H8B) + CHR$(&H46) + CHR$(&HE) ' MOV AX,[BP+0E]
PageCopy$ = PageCopy$ + CHR$(&H8E) + CHR$(&HD8)             ' MOV DS,AX
PageCopy$ = PageCopy$ + CHR$(&H8B) + CHR$(&H76) + CHR$(&HC) ' MOV SI,[BP+0C]
PageCopy$ = PageCopy$ + CHR$(&H8B) + CHR$(&H46) + CHR$(&HA) ' MOV AX,[BP+0A]
PageCopy$ = PageCopy$ + CHR$(&H8E) + CHR$(&HC0)             ' MOV ES,AX
PageCopy$ = PageCopy$ + CHR$(&H8B) + CHR$(&H7E) + CHR$(&H8) ' MOV DI,[BP+08]
PageCopy$ = PageCopy$ + CHR$(&HB9) + CHR$(&H0) + CHR$(&H40) ' MOV CX,7D00
PageCopy$ = PageCopy$ + CHR$(&HF3)                          ' REPZ
PageCopy$ = PageCopy$ + CHR$(&HA5)                          ' MOVSW
PageCopy$ = PageCopy$ + CHR$(&H5D)                          ' POP BP
PageCopy$ = PageCopy$ + CHR$(&H1F)                          ' POP DS
PageCopy$ = PageCopy$ + CHR$(&HCA) + CHR$(&H8) + CHR$(&H0)  ' RETF 0008

FromSeg% = CINT(FromS) 'VARSEG(VS1%(1))
FromOff% = CINT(FromO) 'VARPTR(VS1%(1))
ToSeg% = CINT(ToS) 'VARSEG(VS2%(1))  'If you wanted to copy an array straight to the
					 'screen then this would be = &HA000
ToOff% = CINT(ToO) 'VARPTR(VS2%(1))  'and this would be = 0

DEF SEG = VARSEG(PageCopy$)
'''CALL ABSOLUTE(BYVAL FromSeg%, BYVAL FromOff%, BYVAL ToSeg%, BYVAL ToOff%, SADD(PageCopy$))
DEF SEG

END SUB

 FUNCTION XTimerW& STATIC
'returns time in PIT ticks modulo 30 min
'Slow but safe to use in a DOS box in Windows as in plain DOS
CONST forty = &H40
CONST byte = 256&
		DEF SEG = forty
		IF NOT ini% THEN OUT &H43, &H0: ini% = -1

				T& = INP(forty)
				tpic& = 65536 - (INP(forty) * byte + T&)
xtimerloop:
				T& = PEEK(&H6D)
				ttimer& = PEEK(&H6C) + byte * T&
				IF tpic& < ltpic& THEN IF ttimer& = lttimer& THEN GOTO xtimerloop
				SWAP tpic&, ltpic&: SWAP lttimer&, ttimer&
				XTimerW& = (lttimer& AND &H7FFF) * 65536 + ltpic&
END FUNCTION

